;This file is copyright (c) 1991, 1992 Informant Communications Group and the
;article author. The material here may be used in an application provided
;that this copyright/disclaimer information is kept in the original source
;file. The material presented here is provided "as is" and with no guarantee.
;Informant Communications Group/Paradox Informant assume no responsibility
;for the use or misuse of the material contained within.
;
;Contents        : script Parsdemo
;Source File     : Parsdemo.SC
;Author          : Randolph Brown
;
;Informant Issue : October 1991
;
;Description     : A routine that parses honorifics and names from a single
;                  field to separate fields. Demo includes tables and sample
;                  reports.
;
; Paradox Informant
; 8525 Elk Grove Blvd.
; Suite 126
; Elk Grove, CA  95624-1777
; Phone: (916) 686-6610
; Fax  : (916) 686-8497
; BBS  : (916) 686-4740
;-----------------------------------------------------------------------------


; Parsdemo.sc separates honorifics from a list of names, places them in
; a separate field and then separates last names from first names and
; places them in separate fields as well.

COEDITKEY

SCAN

   RELEASE VARS ALL
   MESSAGE "Record " + STRVAL(RECNO())

   a1 = MATCH([Name], ".. Mrs ..", t1, n1)
   a2 = MATCH([Name], "Sr ..", n2)
   a3 = MATCH([Name], "Miss ..", n3)
   a4 = MATCH([Name], "Mrs ..", n4)
   a5 = MATCH([Name], "Mr ..", n5)
   a6 = MATCH([Name], "Ms ..", n6)
   a7 = MATCH([Name], "Dr ..", n7)
   a8 = MATCH([Name], "Fr ..", n8)
   a9= MATCH([Name], "..", n9)

   SWITCH
      CASE a1 = true:
          n = n1
          [Title] = t1 + " Mrs"
      CASE a2 = true:
          n = n2
          [Title] = "Sr"
      CASE a3 = true:
          n = n3
          [Title] = "Miss"
      CASE a4 = true:
          n= n4
          [Title] = "Mrs"
      CASE a5 = true:
          n = n5
          [Title] = "Mr"
      CASE a6 = true:
          n = n6
          [Title] = "Ms"
      CASE a7 = true:
          n = n7
          [Title] = "Dr"
      CASE a8 = true:
          n = n8
          [Title] = "Fr"
      CASE a9 = true:
          n = n9                   ; case a9 is true for names without
   ENDSWITCH                       ; honorifics, so [Title] is not entered.

   m1  = MATCH(n, "@ @ ..", f1, i1, l1)
   m2  = MATCH(n, "@ .. ..", f2, i2, l2)
   m3  = MATCH(n, ".. @ ..", f3, i3, l3)
   m4  = MATCH(n,".. .., ..", f4, l4, add4)
   m5  = MATCH(n, ".. ..", f5, l5)
   m6  = MATCH(n, ".. .. ..", f6, i6, l6)
   m7  = MATCH(n, ".. .. .. ..", f7, i7, l7, x7)
   m8  = MATCH(n, ".. and .. ..", f8, f8a, l8)
   m9  = MATCH(n, ".. .. .. .. ..",a9, b9, c9, d9, e9)
   m10 = MATCH(n, ".. & .. ..", f10, f10a, l10)
   m11 = MATCH(n, ".. @ .., ..", f11, i11, l11, add11)
   m12 = MATCH(n, ".. .. & .. .. ..", f12, f12a, f12b, f12c, l12)
   m13 = MATCH(n, ".. .. .., ..", f13, f13a, l13, add13)
   m14 = MATCH(n, ".. .. Jr", f14, l14)
   m15 = MATCH(n, "@ .. & .. ..", f15, f15a, f15b, l15)
   m16 = MATCH(n, ".. .. & .. @ ..", f16, f16a, f16b, f16c, l16)
   m17 = MATCH(n, ".. @ @ ..", f17, f17a, f17b, l17)
   m18 = MATCH(n, "@ .. & .. .. ..", f18, f18a, f18b, f18c, l18)
   m19 = MATCH(n, ".. and .. .. ..", f19, f19a, f19b, l19)

   SWITCH
      CASE m11 = true:                              ; case  ".. @ .., .."
          [Fname] = f11 + " " + i11
          [Lname] = l11
          [Add2] = [Add1]
          [Add1] = add11
      CASE m16 = true:                              ; case  ".. .. & .. @ .."
          [Fname] = f16+" "+f16a+" & "+f16b+" "+f16c
          [Lname] = l16
      CASE m10 = true:                              ; case  ".. & .. .."
          [Fname] = f10 + " & " + f10a
          [Lname] = l10
      CASE m17 = true:                              ; case  ".. @ @ .."
          [Fname] = f17+" "+f17a+" "+f17b
          [Lname] = l17
      CASE m13 = true:                              ; case  ".. .. .., .."
          [Fname] = f13+" "+f13a
          [Lname] = l13
          [Add2] = [Add1]
          [Add1] = add13
      CASE m4 = true:                               ; case  ".. .., .."
          [Fname] = f4
          [Lname] = l4
          [Add2] = [Add1]
          [Add1] = add4
      CASE m1 = true:                               ; case  "@ @ .."
          [Fname] = f1 + " " + i1
          [Lname] = l1
      CASE m18 = true:                              ; case "@ .. & .. .. .."
          [Fname] = f18+" "+f18a+" & "+f18b+" "+f18c
          [Lname] = l18
      CASE m15 = true:                              ; case  "@ .. & .. .."
          [Fname] = f15+" "+f15a+" & "+f15b
          [Lname] = l15
      CASE m12 = true:                              ; case ".. .. & .. .. .."
          [Fname] = f12+" "+f12a+" & "+f12b+" "+f12c
          [Lname] = l12
      CASE m2 = true:                               ; case  "@ .. .."
          [Fname] = f2 + " " + i2
          [Lname] = l2
      CASE m19 = true:                              ; case  ".. and .. .. .."
          [Fname] = f19+" & "+f19a+" "+f19b
          [Lname] = l19
      CASE m8 = true:                               ; case   ".. and .. .."
          [Fname] = f8 + " & " + f8a
          [Lname] = l8
      CASE m3 = true:                               ; case   ".. @ .."
          [Fname] = f3 + " " + i3
          [Lname] = l3
      CASE m9 = true:                               ; case  ".. .. .. .. .."
          [Fname] = ""
          [Lname] = ""
          [Add2] = [Add1]
          [Add1] = a9+" "+b9+" "+c9+" "+d9+" "+e9
      CASE m7 = true:                               ; case  ".. .. .. .."
          [Fname] = ""
          [Lname] = ""
          [Add2] = [Add1]
          [Add1] = f7+" "+i7+" "+l7+" "+x7
      CASE m14 = true:                              ;  case  ".. .. Jr"
          [Fname] = f14
          [Lname] = l14 + " Jr"
      CASE m6 = true:                               ; case   ".. .. .."
          [Fname] = f6 + " " + i6
          [Lname] = l6
      CASE m5 = true:                               ; case   ".. .."
          [Fname] = f5
          [Lname] = l5
      OTHERWISE:
          [Lname] = n                               ; case   ".."

   ENDSWITCH

ENDSCAN

Do_it!

